"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.objectMatches = void 0;
const fast_equals_1 = require("fast-equals");
function objectMatches(
// eslint-disable-next-line @typescript-eslint/no-explicit-any
matcher, 
// eslint-disable-next-line @typescript-eslint/no-explicit-any
validatedObject) {
    for (const key in matcher) {
        if (!Object.prototype.hasOwnProperty.call(matcher, key))
            continue;
        if (!Object.prototype.hasOwnProperty.call(validatedObject, key)) {
            return false;
        }
        if (typeof matcher[key] === 'object' && matcher[key] !== null) {
            if (typeof validatedObject[key] !== 'object' || validatedObject[key] === null) {
                return false;
            }
            // eslint-disable-next-line @typescript-eslint/no-unsafe-argument
            if (!objectMatches(matcher[key], validatedObject[key])) {
                return false;
            }
            // eslint-disable-next-line @typescript-eslint/no-unsafe-argument
        }
        else if (!(0, fast_equals_1.deepEqual)(matcher[key], validatedObject[key])) {
            return false;
        }
    }
    return true;
}
exports.objectMatches = objectMatches;
//# sourceMappingURL=matchUtils.js.map